/* AnimationConfig.h */

#ifndef AnimationConfig_loaded
#define AnimationConfig_loaded

#include <stdio.h>
#include "mgos.h"
#include "common/cs_dbg.h"
#include "mjs.h"
#include "LEDDefinition.h"
#include "LEDState.h"

#define MAX_ANIMATION_STEPS 100

typedef struct AnimationStep_t {
	uint8_t ledIndex;
	LEDMode ledMode;
	uint32_t durationTicks;
} AnimationStep;

typedef struct AnimationConfig_t {
		uint16_t numberAnimationSteps;
		AnimationStep animationStep[MAX_ANIMATION_STEPS];
} AnimationConfig;

extern AnimationConfig theAnimationConfig;

extern void AnimationConfig_init(bool loadDefaultData);
extern uint16_t getNumberOfAnimationSteps();
extern void AnimationStep_add(uint8_t ledIndex, LEDMode m, uint32_t duration);
extern uint16_t AnimationConfig_getNextAnimationStepForLED(uint8_t led, uint16_t currentAnimationStep);

#endif
